Subject: [NSIS] Maximum Packet Size Parameter <M> -- Re: Last Call: draft-ietf-nsis-qspec (QoS NSLP QSPEC Template) to Informational RFC

From: "Georgios Karagiannis" <[email-masked]>
Date: Tue, 08 Dec 2009 06:50:56 +0000

Hi Jerry

I think that the reason of removing the  "Maximum Packet Size [M]
(32-bit unsigned integer)" parameter from the QSPEC specification was
that this parameter is only relevant for some QoS models that are used
on an end-to-end basis, such as Y.1541 QOSM. I would therefore prefer
that this parameter should not be specified in the QSPEC draft.
In my opinion this parameter should be specified as an TMOD extension in
any QoS model that needs it. I believe that Y.1541 QOSM already does
specify the "Maximum Packet Size [M] (32-bit unsigned integer)"
parameter in Section 3.1.

Best regards,
Georgios

On 11/30/2009, "Gerald Ash" <[email-masked]> wrote:

>All,
> 
>Al Morton has recently raised concerns RE taking the Maximum Packet Size <M> parameter out of the QSPEC document.  Based on his comments (given below, along with other background), it appears that the <M> parameter should be put back into the QSPEC.
> 
>
>Please comment on whether the <M> parameter should be put back into the QSPEC.
> 
>Thanks,
>Jerry
> 
>Background:
> 
>The Maximum Packet Size Parameter <M> was taken out back in July 2005 in QSPEC version 5, with the following explanation in the change history:
>
>
> 
>"   Version -05:
>
>   - discarded QSPEC parameter <M> (Maximum packet size) since MTU
>     discovery is expected to be handled by procedure currently defined
>     by PMTUD WG"
> 
>Some further explanation for removing the parameter <M> is given in a message posted by Cornelia Kappler on the IETF web-site at http://www.ietf.org/mail-archive/web/nsis/current/msg07923.html:
> 
>"AW: [NSIS] smallest path MTU - Maximum Packet Size [M]
>
>
>
>
>To: "ext Bernd Schloer" <bschloer at cs.uni-goettingen.de>, <nsis at ietf.org> 
>Subject: AW: [NSIS] smallest path MTU - Maximum Packet Size [M] 
>From: "Kappler, Cornelia" <cornelia.kappler at nsn.com> 
>Date: Fri, 1 Jun 2007 09:53:50 +0200 
>Cc: 
>In-reply-to: <[email-masked]> 
>List-help: <mailto:[email-masked]?subject=help> 
>List-id: Next Steps in Signaling <nsis.ietf.org> 
>List-post: <mailto:[email-masked]> 
>List-subscribe: <https://www1.ietf.org/mailman/listinfo/nsis>, <mailto:[email-masked]?subject=subscribe> 
>List-unsubscribe: <https://www1.ietf.org/mailman/listinfo/nsis>, <mailto:[email-masked]?subject=unsubscribe> 
>References: <[email-masked]> 
>Thread-index: AceiOM3OwdCeaEOuS267eWNZJzBL6QB6Qufg 
>Thread-topic: [NSIS] smallest path MTU - Maximum Packet Size [M] 
>
>Hi all, 
>
>at the Interim meeting in May 2005 we decided to drop the MTU, see  http://www.ietf-nsis.org/nsis/Munich_Interim_Meeting/MeetingMinutes.html 
>
>Cornelia 
>
>> -----Ursprüngliche Nachricht-----
>> Von: ext Bernd Schloer [mailto:bschloer at cs.uni-goettingen.de] 
>> Gesendet: Dienstag, 29. Mai 2007 23:31
>> An: nsis at ietf.org
>> Betreff: [NSIS] smallest path MTU - Maximum Packet Size [M]
>> 
>> Hi,
>> 
>> in version 13 of the QSPEC-draft the Maximum Packet Size [M] 
>> was removed from the
>> TMOD parameter (former Traffic parameter).
>> 
>> RFC2211 mentions, that links are not permitted to fragment 
>> packets which receive
>> the controlled-load service and packets larger than the MTU 
>> of the link are treated
>> as non-conformant to the TSPEC.
>> 
>> What was the reason to omit this parameter?
>> 
>> Best regards,
>> Bernd"
>Hannes Tschofenig kindly provided links to the Munich Interim Meeting Minutes at
>
>http://www.tschofenig.priv.at/nsis/munich/MeetingMinutes.html
> 
>It appears that the discussion of MTU discovery somehow led to a conclusion that the maximum packet size parameter <M> should be eliminated as well, as documented in this portion of the minutes:
> 
>"A QoS Model for Signaling IntServ Controlled-Load Service with NSIS
>===================================================================
>
>http://www.ietf.org/internet-drafts/draft-kappler-nsis-qosmodel-controlledload-01.txt 
>Slides: http://www.ietf-nsis.org/nsis/Munich_Interim_Meeting/Ctrld_Load_QOSM_Interim_Munich.ppt
>
>Cornelia Kappler presents and she starts with an overview of IntServ.
>
>What is IntServ Controlled-Load service?
>-IntServ Controlled Load Service is (in NSIS terms) a QoS Model
>-RFC 2210 specifies how to signal for Controled load using RSVP
>-This ID specifies how to signal for Controled Load using NSIS
>-Controlled-Load Service (RFC 2211)
>-Provides approximatively service of an unloaded best-effort network
>-QoS parameters signaled are Token Bucket and MTU
>-Implemented per "network element", i.e. per-router or per-subnet
>Can be used for 
>Reserving resources per-flow per-router
>Admission control at edge of Diffserv domains
>Admission control into MPLS clouds
>
>How to signal for Controlled Load service with NSIS
>-Role of QNEs
>-One or more QNR per "network element"
>-Stateless QNEs?
>-Provide approximatively service of an uiloaded best-effort network may also be possible with stateless QNEs
>
>Discussion started about MTU insertion in the QoS NSLP since not all routers would be supporting the NSIS Qos NSLP it was decided to remove the MTU discovery from controlled load and Qos-NSLP draft. If required MTU discovery would be using mechanisms out of scope of NSIS (PMTUD or other)"
> 
>Bernd Schloer raised the concern of eliminating <M> in his message referenced above:
> 
>"In version 13 of the QSPEC-draft the Maximum Packet Size [M] was removed from the TMOD parameter (former Traffic parameter).
>
>RFC2211 mentions, that links are not permitted to fragment packets which receive the controlled-load service and packets larger than the MTU of the link are treated as non-conformant to the TSPEC.
>
>What was the reason to omit this parameter?"
> 
>Al Morton raised the same and additional concerns in a recent discussion:
> 
>"It seems to me that  several points were missed
>by citing the Packetization Layer Path MTU Discovery (PLPMTUD)
>[note: see RFC 4821 http://www.rfc-editor.org/rfc/rfc4821.txt]
>as a replacement for specifying M, Max Pkt size:
>
> -  only the sending end-point will store what PLPMTUD discovers,
>    intermediate points where shaping or policing reside will not
>    know the Max pkt size the sender intends to use.
>
> -  the Max packet size that a sender uses may be much less than MTU,
>    VoIP is the most obvious example.
>
>Or, it wasn't understood that M was a critical part of the peak 
>rate definition.  From RFC 2212:
>   The peak rate, p, is measured in bytes of IP datagrams per second and
>   has the same range and suggested representation as the bucket rate.
>   The peak rate is the maximum rate at which the source and any
>   reshaping points (reshaping points are defined below) may inject
>   bursts of traffic into the network.  More precisely, it is a
>   requirement that for all time periods the amount of data sent cannot
>   exceed M+pT where M is the maximum datagram size and T is the length
>   of the time period. 
>
>Note that parameter M is part of the RFC 2212 TSPEC, and M is apparently
>different from the MTU:
>   Links are not permitted to fragment datagrams as part of guaranteed
>   service.  Datagrams larger than the MTU of the link MUST be policed
>   as non-conformant which means that they will be policed according to
>   the rules described in the Policing section below."
> 
>It seems that Bernd and Al have raised valid concerns: discovery of MTU does not eliminate the need to specify <M> in the TMOD parameter.  It appears that the <M> parameter should be put back in the QSPEC.  It should not be a big issue since <M> was already there in the QSPEC up through version 4 (see http://www.watersprings.org/pub/id/draft-ietf-nsis-qspec-04.txt).
>  
>
>
>--- On Wed, 11/11/09, The IESG <[email-masked]> wrote:
>
>
>From: The IESG <[email-masked]>
>Subject: [NSIS] Last Call: draft-ietf-nsis-qspec (QoS NSLP QSPEC Template) to Informational RFC
>To: "IETF-Announce" <[email-masked]>
>Cc: [email-masked]
>Date: Wednesday, November 11, 2009, 4:09 AM
>
>
>The IESG has received a request from the Next Steps in Signaling WG 
>(nsis) to consider the following document:
>
>- 'QoS NSLP QSPEC Template '
>   <draft-ietf-nsis-qspec-22.txt> as an Informational RFC
>
>The IESG plans to make a decision in the next few weeks, and solicits
>final comments on this action.  Please send substantive comments to the
>[email-masked] mailing lists by 2009-11-25. Exceptionally, 
>comments may be sent to [email-masked] instead. In either case, please 
>retain the beginning of the Subject line to allow automated sorting.
>
>The file can be obtained via
>http://www.ietf.org/internet-drafts/draft-ietf-nsis-qspec-22.txt
>
>
>IESG discussion can be tracked via
>https://datatracker.ietf.org/public/pidtracker.cgi?command=view_id&dTag=12323&rfc_flag=0
>
>_______________________________________________
>nsis mailing list
>[email-masked]
>https://www.ietf.org/mailman/listinfo/nsis
>
>
>
>      )

---

From: Gerald Ash <[email-masked]>
Date: Thu, 10 Dec 2009 08:39:16 -0800 (PST)

Georgios,
 
The maximum packet size (M) sub-parameter is a required element of the traffic model (TMOD) parameter specified in the QSPEC.  TMOD is modeled after the RSVP Tspec parameter (see RFC 2210 http://www.rfc-editor.org/rfc/rfc2210.txt and RFC 2212 http://www.rfc-editor.org/rfc/rfc2212.txt), which consists of 5 sub-parameters: 
 
rate (r)
bucket size (b)
peak rate (p)
minimum policed unit (m)
maximum packet size (M)
 
The TMOD parameter is mandatory for the QNI to include in the initiator QSPEC and mandatory for downstream QNEs to interpret.  As such, the TMOD parameter and M sub-parameter apply to ALL QOSM's, including Y.1541, RMD, etc., and must be used by them.
 
As explained in the attached email below, the M sub-parameter was erroneously removed from the QSPEC in version 5 when it was incorrectly assumed that automatic discovery of MTU would also apply to M.  It does not, MTU and M are not the same parameter.  Fortunately this error was recently brought to our attention by Al Morton (and earlier by Bernd Schloer).
 
Therefore M needs to be put back in the QSPEC, as Jukka has correctly agreed.
 
Thanks,
Jerry

--- On Tue, 12/8/09, Georgios Karagiannis <[email-masked]> wrote:

From: Georgios Karagiannis <[email-masked]>
Subject: [NSIS] Maximum Packet Size Parameter <M> -- Re: Last Call: draft-ietf-nsis-qspec (QoS NSLP QSPEC Template) to Informational RFC
To: "Gerald Ash" <[email-masked]>, "IETF-Announce" <[email-masked]>, "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>
Date: Tuesday, December 8, 2009, 1:50 AM

Hi Jerry

Best regards,
Georgios

---

From: "Georgios Karagiannis" <[email-masked]>
Date: Fri, 11 Dec 2009 09:10:35 +0000

Hi Jerry

As long as the current specified QSPEC processing rules are not affected
it is okay with me to include the maximum packet size (M) subparameter
into TMOD.

Furthermore, please see in line!

>The maximum packet size (M) sub-parameter is a required element of the traffic model (TMOD) parameter specified in the QSPEC.  TMOD is modeled after the RSVP Tspec parameter (see RFC 2210 http://www…

Georgios: The NSIS WG had decided to use only 4 parameters, see QSPEC
draft (v.22):, section 3.3.1:
o rate (r) specified in octets per second
o bucket size (b) specified in octets
o peak rate (p) specified in octets per second
o minimum policed unit (m) specified in octets

>The TMOD parameter is mandatory for the QNI to include in the initiator QSPEC and mandatory for downstream QNEs to interpret.  As such, the TMOD parameter and M sub-parameter apply to ALL QOSM's, in…

Georgios: I think that the QSPEC draft describes in a good way how TMOD
is processed by QNEs and local QoS models.

>As explained in the attached email below, the M sub-parameter was erroneously removed from the QSPEC in version 5 when it was incorrectly assumed that automatic discovery of MTU would also apply to…

Georgios: Please note that the maximum packet size (M) subparameter was
removed in v.13 of the QSPEC draft. In v.12 of the QSPEC draft the
maximum packet size (M) subparameter was specified, see Section 7.2.2 of
version 12 of the QSPEC.
So I do not know what was the reason of removing the M subparameter from
TMOD.

However, as long as the current QSPEC/TMOD processing rules are not
affected it is okay with me to include the maximum packet size (M)
subparameter into TMOD.

Best regards,
Georgios